<?php

class PayshopMBWayDialog
{
    /**
     * Class constructor
     */
    public function __construct()
    {
        add_action('woocommerce_after_register_post_type ', [$this, 'execute']);
    }

    /**
     * Show MBWay dialog on thank you page
     *
     * @return void
     */
    public function execute()
    {
        add_action('woocommerce_thankyou', [$this, 'showDialog']);
        
    }

    /**
     * Show MBWay dialog
     *
     * @return void
     */
    public function showDialog()
    {
        $orderId = wc_get_order_id_by_order_key($_GET['key']);
        $order = wc_get_order($orderId);

        if ($order->get_payment_method() !== 'payshop_mbway') {
            return;
        }

        $orderStatus = $order->get_status();
        if ('processing' === $orderStatus || 
            'completed' === $orderStatus ||
            'failed' === $orderStatus) {
            return;
        }

        require_once PAYSHOP_PLUGIN_DIR . '/templates/views/front/mbway-dialog.php';
    }
}
