<?php

class PayshopReferencesEmail
{
    /**
     * Class constructor
     */
    public function __construct()
    {
        add_action('woocommerce_email_after_order_table', [$this, 'addPayshopReferences'], 10, 4);
    }

    /**
     * Add payshop references to email
     *
     * @param WC_Order $order
     * @param bool $sent_to_admin
     * @param bool $plain_text
     * @param WC_Email $email
     * @return void
     */
    public function addPayshopReferences($order, $sent_to_admin, $plain_text = false, $email)
    {
        if ($order->get_payment_method() !== 'payshop_multibanco' &&
            $order->get_payment_method() !== 'payshop_reference') {
            return;
        }

        if (!$sent_to_admin && $order->has_status( 'on-hold' )) {
            //used on template
            $referenceEntity = $order->get_meta('_payshop_entity');
            $reference = $order->get_meta('_payshop_reference');
            $referenceEndDate = $order->get_meta('_payshop_end_date');

            require_once PAYSHOP_PLUGIN_DIR . '/templates/views/front/references-email.php';
        }
    }
}