var payshop_vObj, payshop_vFun;

// input mask
// eslint-disable-next-line no-unused-vars
function payshop_maskInput (o, f) {
payshop_vObj = o;
payshop_vFun = f;
setTimeout(payshop_execmascara(), 1);
}

// eslint-disable-next-line no-unused-vars
function payshop_execmascara () {
payshop_vObj.value = payshop_vFun(payshop_vObj.value);
}

// eslint-disable-next-line no-unused-vars
function payshop_date (v) {
v = v.replace(/\D/g, '');
v = v.replace(/(\d{2})(\d)/, '$1/$2');
v = v.replace(/(\d{2})(\d{2})$/, '$1$2');
return v;
}

// eslint-disable-next-line no-unused-vars
function payshop_minteger (v) {
return v.replace(/\D/g, '');
}

// eslint-disable-next-line no-unused-vars
function payshop_cc (v) {
v = v.replace(/\D/g, '');
v = v.replace(/^(\d{4})(\d)/g, '$1 $2');
v = v.replace(/^(\d{4})\s(\d{4})(\d)/g, '$1 $2 $3');
v = v.replace(/^(\d{4})\s(\d{4})\s(\d{4})(\d)/g, '$1 $2 $3 $4');
return v;
}

/**
 * Card scope
 */
(function () {
    /**
     * Get form
     */
    function getCardForm() {
        return document.querySelector('.woocommerce-checkout');
    }

    /**
     * Disable error spans
     */
    function hideErrors() {
        for (var x = 0; x < document.querySelectorAll('[data-checkout]').length; x++) {
            var field = document.querySelectorAll('[data-checkout]')[x];
            field.classList.remove('payshop-form-control-error');
        }

        for (var y = 0; y < document.querySelectorAll('.payshop-erro-form').length; y++) {
            var small = document.querySelectorAll('.payshop-erro-form')[y];
            small.style.display = 'none';
        }
    }

    /**
     * Validate inputs
     */
    function validateInputs() {
        hideErrors();

        var inputsNotFilled = validateinputNotFilled();
        var numberIsInvalid = cardNumberIsInvalid();
        var expirationIsInvalid = expirationDateIsInvalid();
        var codeIsInvalid = cvvIsInvalid();

        if (inputsNotFilled || codeIsInvalid || expirationIsInvalid || numberIsInvalid) {
            return false;
        }

        return true;
    }

    /**
   * Validate card number length
   */
    function cardNumberIsInvalid() {
        var span = getCardForm().querySelectorAll('small[data-main="#id-card-number"]');
        var cvvInput = document.getElementById('id-card-number');
        var numberIsInvalid = cvvInput.value.length < 19;

        if (numberIsInvalid) {
            span[0].style.display = 'block';
            cvvInput.classList.add('payshop-form-control-error');
            cvvInput.focus();
        }

        return numberIsInvalid;
    }

    /**
     * Validate Expiration Date
     */
    function expirationDateIsInvalid() {
        var span = getCardForm().querySelectorAll('small[data-main="#id-card-expiration"]');
        var expirationInput = document.getElementById('id-card-expiration');

        //validate string length
        var invalidSize = expirationInput.value.length != 7;

        var expirationMonth = expirationInput.value.substring(0, 2) - 1;
        var expirationYear = expirationInput.value.substring(3, 7);

        //validate month
        var invalidMonth = expirationMonth < 0 || expirationMonth > 11;

        //validate year
        var invalidYear = expirationYear > new Date().getFullYear() + 15;

        //validate full date
        var lastDayOfPreviousMonth = new Date();
        lastDayOfPreviousMonth.setDate(0);

        var expirationDate = new Date(expirationYear, expirationMonth);

        var invalidDate = expirationDate < lastDayOfPreviousMonth;

        var invalid = invalidSize || invalidMonth || invalidYear || invalidDate;

        if (invalid) {
            span[0].style.display = 'block';
            expirationInput.classList.add('payshop-form-control-error');
            expirationInput.focus();
        }

        return invalid;
    }

    /**
     * Validate CVV length
     */
    function cvvIsInvalid() {
        var span = getCardForm().querySelectorAll('small[data-main="#id-security-code"]');
        var cvvInput = document.getElementById('id-security-code');
        var cvvIsInvalid = cvvInput.value.length < 3;

        if (cvvIsInvalid) {
            span[0].style.display = 'block';
            cvvInput.classList.add('payshop-form-control-error');
            cvvInput.focus();
        }

        return cvvIsInvalid;
    }

    /**
     * Validate fixed Inputs is empty
     */
    function validateinputNotFilled() {
        var emptyInputs = false;
        var form = getCardForm();
        var formInputs = form.querySelectorAll('[data-checkout]');
        var fixedInputs = ['cardNumber', 'cardholderName', 'cardExpiration', 'securityCode', 'installments'];

        for (var x = 0; x < formInputs.length; x++) {
            var element = formInputs[x];

            // Check is a input to create token.
            if (fixedInputs.indexOf(element.getAttribute('data-checkout')) > -1) {
                if (element.value === -1 || element.value === '') {
                    var span = form.querySelectorAll('small[data-main="#' + element.id + '"]');

                    if (span.length > 0) {
                        span[0].style.display = 'block';
                    }

                    element.classList.add('payshop-form-control-error');
                    emptyInputs = true;
                }
            }
        }

        return emptyInputs;
    }

    /**
     * Validate if card is selected and validate inputs
     */
    function validateEvent(checkoutForm) {
        if (checkoutForm.find('#payment_method_payshop_card').is(':checked')) {
            return validateInputs();
        }
    }

    /**
     * Handle submit from credit card form
     */
    jQuery(function ($) {
        let checkoutForm = $('form.woocommerce-checkout');
        let isNormalCheckout = checkoutForm.length > 0;

        if (isNormalCheckout) {
            checkoutForm.on('checkout_place_order', function (e) {
                return validateEvent(checkoutForm);
            });
        } else {
            // After failed payment, on order-pay page
            checkoutForm = $('form#order_review');

            checkoutForm.find('#place_order').click(function () {
                return validateEvent(checkoutForm);
            });
        }
    });
})();